angular.module('starter.controllers', ['ionic'])

.directive('input', function($timeout) {
    return {
        restrict: 'E',
        scope: {
            'returnClose': '=',
            'onReturn': '&',
            'onFocus': '&',
            'onBlur': '&'
        },
        link: function(scope, element, attr) {
            element.bind('focus', function(e) {
                if (scope.onFocus) {
                    $timeout(function() {
                        scope.onFocus();
                    });
                }
            });
            element.bind('blur', function(e) {
                if (scope.onBlur) {
                    $timeout(function() {
                        scope.onBlur();
                    });
                }
            });
            element.bind('keydown', function(e) {
                if (e.which == 13) {
                    if (scope.returnClose) element[0].blur();
                    if (scope.onReturn) {
                        $timeout(function() {
                            scope.onReturn();
                        });
                    }
                }
            });
        }
    };
})
    .controller('ChatCtrl', function($scope, $timeout, $ionicScrollDelegate) {
        var isIOS = ionic.Platform.isWebView() && ionic.Platform.isIOS();

        $scope.msgs = [{
            id: 0,
            from: 0,
            text: "Hey, how is everything going?"
        }, {
            id: 1,
            from: 1,
            text: "What's up?"
        }, {
            id: 2,
            from: 0,
            text: "Nothing. Watching the game, having a Bud."
        }, {
            id: 3,
            from: 1,
            text: "True, true..."
        }];

        $scope.sendChat = function(msg) {
            if (msg != null && msg.text != null && msg.text != "") {
                $scope.msgs.push({
                    id: $scope.msgs.length,
                    from: 1,
                    text: msg.text
                });
                delete $scope.msg.text;
                $ionicScrollDelegate.scrollBottom(true);
                answer();
            }
        };

        var answers = [
            "cool",
            "Oh really?",
            "I don't think this 'internet' will catch on...",
            "Any plans for the weekend?",
            "Where will you take me for Valentine's Day? I totally want to try lobster at this new restaurant! Please!",
            "What do you expect? I'm just a bot.",
            "Hallo. Guten Tag. Ich spreche etwas deutsch.",
            "ok?",
            "lol"
        ];

        function answer() {
            $timeout(function() {
                $scope.msgs.push({
                    id: $scope.msgs.length,
                    from: 0,
                    text: answers[Math.floor(Math.random() * answers.length)]
                });
                $ionicScrollDelegate.scrollBottom(true);
            }, Math.floor(Math.random() * 3500) + 500);

        }

        $scope.inputUp = function() {
            if (isIOS) $scope.data.keyboardHeight = 216;
            $timeout(function() {
                $ionicScrollDelegate.scrollBottom(true);
            }, 300);

        };

        $scope.inputDown = function() {
            if (isIOS) $scope.data.keyboardHeight = 0;
            $ionicScrollDelegate.resize();
        };

        $scope.closeKeyboard = function() {
            //cordova.plugins.Keyboard.close();
        };
    });